﻿@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.Common().DevExpress().GridView(
setting =>
{

    setting.Name = "CalculatedKeihenGrid";
    setting.Width = Unit.Percentage(100);
    //setting.Settings.ShowFilterRow = true;
    //setting.Settings.ShowFilterRowMenu = true;
    setting.Settings.ShowColumnHeaders = true;
    setting.KeyFieldName = "PACK_MONTH";

    setting.CallbackRouteValues = new { Controller = "Keihen", Action = "ReloadCalculatedKeihenGrid" };
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackCalculatedGrid";
    setting.ClientSideEvents.EndCallback = "OnEndCallbackCalculatedGrid";
    setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
    setting.SettingsBehavior.AllowSelectByRowClick = true;
    setting.SettingsLoadingPanel.Mode = GridViewLoadingPanelMode.Disabled;

    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    setting.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Styles.Header.VerticalAlign = VerticalAlign.Middle;

    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;
    setting.SettingsPager.ShowNumericButtons = true;
    setting.SettingsPager.Position = PagerPosition.Bottom;
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";

    setting.CustomJSProperties = (s, e) =>
    {
        MVCxGridView grid = (MVCxGridView)s;
        int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
        int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
        object[] PackMonth = new object[end - startIndex];
        for (int n = startIndex; n < end; n++)
        {
            PackMonth[n - startIndex] = grid.GetRowValues(n, "PACK_MONTH");
        }
        e.Properties["cpPackMonth"] = PackMonth;
        grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
    };

    
    setting.CommandColumn.VisibleIndex = 0;
    setting.CommandColumn.ShowSelectCheckbox = true;

    setting.Columns.Add(
            sh =>
            {
                sh.Name = "Edit";
                sh.Caption = "";
                sh.Width = Unit.Percentage(10);
                sh.CellStyle.VerticalAlign = VerticalAlign.Middle;
                sh.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                sh.SetDataItemTemplateContent(
                content =>
                {
                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                    Html.DevExpress().HyperLink(
                        link =>
                        {
                            link.Name = "lnkEdit_" + content.VisibleIndex;
                            link.NavigateUrl = "javascript:void(0)";
                            link.Properties.Text = "Edit";
                            link.ClientVisible = true;
                            link.Width = 100;
                            link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnEditClick('{0}', '{1}', '{2}'); }}", 
                                    DataBinder.Eval(content.DataItem, "PACK_MONTH") == null ? "" : DataBinder.Eval(content.DataItem, "PACK_MONTH").ToString(),
                                    DataBinder.Eval(content.DataItem, "FEEDBACK_REMINDER_START") == null ? "" : DataBinder.Eval(content.DataItem, "FEEDBACK_REMINDER_START").ToString(),
                                    DataBinder.Eval(content.DataItem, "FEEDBACK_REMINDER_END") == null ? "" : DataBinder.Eval(content.DataItem, "FEEDBACK_REMINDER_END").ToString());
                        }).Render();
                });

            });
    
    setting.Columns.Add(col =>
    {
        col.FieldName = "PACK_MONTH";
        col.Caption = "Production Month";
        col.Width = Unit.Percentage(50);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    //setting.Columns.Add(col =>
    //{
    //    col.FieldName = "CAR_CD";
    //    col.Caption = "CFC";
    //    col.Width = Unit.Pixel(80);
    //    col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
    //    col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
    //    col.CellStyle.VerticalAlign = VerticalAlign.Middle;
    //    col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    //});

    setting.Columns.Add(
            sh =>
            {
                sh.Name = "Download";
                sh.Caption = "Download";
                sh.Width = Unit.Percentage(40);
                sh.CellStyle.VerticalAlign = VerticalAlign.Middle;
                sh.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                sh.SetDataItemTemplateContent(
                    content =>
                    {
                        Html.DevExpress().HyperLink(
                            image =>
                            {
                                image.Name = "RevisionDownload_" + content.VisibleIndex;
                                image.NavigateUrl = "javascript:void(0)";
                                image.Properties.ImageUrl = "~/Content/Images/xls_icon.png";
                                image.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ DownloadCalculatedKeihenData('{0}'); }}",
                                    DataBinder.Eval(content.DataItem, "PACK_MONTH") == null ? "" : DataBinder.Eval(content.DataItem, "PACK_MONTH").ToString());
                                //image.ClientVisible = (bool)DataBinder.Eval(content.DataItem, "CompletenessCheck");
                            }).Render();
                    });

            });

    setting.Columns.Add(col =>
    {
        col.FieldName = "APPROVED_BY";
        col.Caption = "Approved By";
        col.Width = Unit.Percentage(60);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "APPROVED_DT";
        col.Caption = "Approved Date";
        col.Width = Unit.Percentage(60);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "FEEDBACK_REMINDER_START";
        col.Caption = "Feedback Reminder Start";
        col.Width = Unit.Percentage(40);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "FEEDBACK_REMINDER_END";
        col.Caption = "Feedback Reminder End";
        col.Width = Unit.Percentage(40);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

}).Bind(Model.GetModel<Portal.Models.Keihen.CalculatedKeihenData>().CModel).GetHtml()




